/* ex4.c	-- Yasuhiro Yamazaki Tue Oct 23 2001
 */
#include <stdio.h>
#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

#include "hand.h"
#include "handutility.h"

/* ɥξ֤򼨤 */
#define WINDOW_STATE_SHOW 0
#define WINDOW_STATE_HIDE 1

/* ǥο */
#define KEY_MODEL_MAX 3

/* ǥֹ */
#define KEY_MODEL_GU    0
#define KEY_MODEL_CHOKI 1
#define KEY_MODEL_PA    2

/* ž ɥʬɥåȤɤž뤫򼨤 */
#define ROTATION_COEFFICIENT 180.0 /* degree */

/* Static ѿ */
static HandModel *state = NULL;                /* θߤΥǥ */
static HandModel *model[ KEY_MODEL_MAX ];      /* ǥ */
static HandModel *target = NULL;               /* ֤ΤΥǥ */
static int windowState = WINDOW_STATE_SHOW;    /* ɥξ */
static double ratio_x = 0.0, ratio_y = 0.0;    /* ޥɸη׻ݻ */
static float rotate_x = 0.0f, rotate_y = 0.0f; /* ɽǥβž */

/*  */
static void
initializeAll( void )
{
  if( state==NULL ){
    /* θߤΥǥ */
    state = createHandModel();
  } 
  if( model[ KEY_MODEL_GU ]==NULL ){
    /* μΥǥ */
    model[ KEY_MODEL_GU ] = createHandModel2( HANDMODEL_TYPE_GU );
  }
  if( model[ KEY_MODEL_CHOKI ]==NULL ){
    /* 祭μΥǥ */
    model[ KEY_MODEL_CHOKI ] = createHandModel2( HANDMODEL_TYPE_CHOKI );
  }
  if( model[ KEY_MODEL_PA ]==NULL ){
    /* ѡμΥǥ */
    model[ KEY_MODEL_PA ] = createHandModel2( HANDMODEL_TYPE_PA );
  }

  /* åȤȤʤ륭ǥ򸽺ߤΥǥ˥å */
  target = state;
}

/*  */
static void
freeAll( void )
{
  int i;
  
  if( state!=NULL ){
    destroyHandModel( state );
    state = NULL;
  }
  for( i=0; i<KEY_MODEL_MAX; i++ ){
    if( model[i]!=NULL ){
      destroyHandModel( model[i] );
      model[i] = NULL;
    }
  }
}

/* ɽ */
static void
putHand( void )
{
  glPushMatrix();
    glRotatef( rotate_y, 0.0f, 1.0f, 0.0f );
    glRotatef( rotate_x, 1.0f, 0.0f, 0.0f );
    putHandModel( state );
  glPopMatrix();
}

/* ޥɸΥɥФ׻ */
static void
calculationRatioOfMouseCoordinate( const int x, const int y )
{
  int width, height;
  width  = glutGet( GLUT_WINDOW_WIDTH );
  height = glutGet( GLUT_WINDOW_HEIGHT );
  ratio_x = (double)y/(double)height;
  ratio_y = (double)x/(double)width;
}

/* 褬ɬפȤʤä˸ƤФ */
static void
displayCallback( void )
{
  glLoadIdentity();
  gluLookAt( 10.0, 10.0, 20.0, 0.0, 5.0, 0.0, 0.0, 1.0, 0.0 );

  glClear( GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT );

  putHand();
  
  glutSwapBuffers();
}

/* ɥꥵ줿˸ƤФ */
static void
reshapeCallback( int width, int height )
{
  glViewport( 0, 0, width, height );

  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  gluPerspective( 60.0, width/(GLdouble)height, 0.01, 100 );

  glMatrixMode( GL_MODELVIEW );
}

/* ɥϾƤФ */
static void
idleCallback( void )
{
  if( windowState==WINDOW_STATE_SHOW ){
    /* ɥ˹Ԥ򤳤˵ */
    if( state!=NULL && target!=NULL ){
      interpolationHandModel( state, state, target, 0.05f );
    }
    glutPostRedisplay();
  }
}

/* ɥ{ɽ/줿}˸ƤФ */
static void
visibilityCallback( int state )
{
  switch( state ){
  case GLUT_NOT_VISIBLE:
    fprintf( stderr, "THE WINDOW WAS HIDDEN.\n" );
    windowState = WINDOW_STATE_HIDE;
    break;
  case GLUT_VISIBLE:
    fprintf( stderr, "THE WINDOW WAS SHOWN.\n" );
    windowState = WINDOW_STATE_SHOW;
    break;
  }
}

/* ޥΥܥѲä˸ƤФ */
static void
mouseCallback( int button, int state, int x, int y )
{
  switch( button ){
  case GLUT_LEFT_BUTTON:
    fprintf( stderr, "LEFT BUTTON: " );
    break;
  case GLUT_MIDDLE_BUTTON:
    fprintf( stderr, "MIDDLE BUTTON: " );
    break;
  case GLUT_RIGHT_BUTTON:
    fprintf( stderr, "RIGHT BUTTON: " );
    break;
  }
  
  switch( state ){
  case GLUT_DOWN:
    fprintf( stderr, "DOWN\n" );
    break;
  case GLUT_UP:
    fprintf( stderr, "UP\n" );
    break;
  }

  calculationRatioOfMouseCoordinate( x, y );
}

/* ޥΥݥ󥿤ưä˸ƤФ */
static void
passiveMotionCallback( int x, int y )
{
  fprintf( stderr, "MOUSE (%d, %d)\n", x, y );
}

/* ɥå桢ޥΥݥ󥿤ưä˸ƤФ */
static void
motionCallback( int x, int y )
{
  double rx, ry;

  fprintf( stderr, "DRAG (%d, %d)\n", x, y );

  rx = ratio_x;
  ry = ratio_y;
  calculationRatioOfMouseCoordinate( x, y );
  rotate_x += (float)((ratio_x-rx)*ROTATION_COEFFICIENT);
  rotate_y += (float)((ratio_y-ry)*ROTATION_COEFFICIENT);
}

/* Ϥä˸ƤФ */
static void
keyboardCallback( unsigned char key, int x, int y )
{
  fprintf( stderr, "HIT \'%c\' KEY (CODE: %d)\n", (key<32)?'?':key, (int)key );

  switch( key ){
  /*
  ** Esc줿ץλ
  */
  case 27:
    exit( EXIT_SUCCESS );
    break;

  case 'g':
  case 'G':
    /* ֤륿åȤ򥰡˥å */
    target = model[ KEY_MODEL_GU ];
    break;
    
  case 'c':
  case 'C':
    /* ֤륿åȤ祭˥å */
    target = model[ KEY_MODEL_CHOKI ];
    break;
    
  case 'p':
  case 'P':
    /* ֤륿åȤѡ˥å */
    target = model[ KEY_MODEL_PA ];
    break;
    
  default:
    break;
  }
}

/*  */
static void
initGL( void )
{
  int width, height;

  width  = glutGet( GLUT_WINDOW_WIDTH );
  height = glutGet( GLUT_WINDOW_HEIGHT );

  reshapeCallback( width, height );

  glClearColor( 0.0, 0.0, 0.0, 1.0 );
  glEnable( GL_DEPTH_TEST );
}

/* MAIN */
int
main( int argc, char *argv[] )
{
  glutInit( &argc, argv );
  glutInitDisplayMode( GLUT_DOUBLE|GLUT_RGB|GLUT_DEPTH );

  glutCreateWindow( "ex4 HAND ANIMATION" );

  glutDisplayFunc      ( displayCallback       );
  glutKeyboardFunc     ( keyboardCallback      );
  glutReshapeFunc      ( reshapeCallback       );
  glutIdleFunc         ( idleCallback          );
  glutVisibilityFunc   ( visibilityCallback    );
  glutMouseFunc        ( mouseCallback         );
  glutPassiveMotionFunc( passiveMotionCallback );
  glutMotionFunc       ( motionCallback        );
  
  initGL();
  initializeAll();
  
  glutMainLoop();

  freeAll();
  
  return EXIT_SUCCESS;
}
